=== testsuite/tests/typecheck/should_fail/Makefile ===
TOP=../../..
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONEY: foo

foo:
	echo hello
